// euclide_etendu.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
long x,y;
long e,phi;
long u[3];
long v[3];
long t[3];
long U,V;
int i;
int print=0;
FILE * output=NULL;
//usage
void usage() {
  fprintf(stderr, "Usage: euclide_etendu -x X -y Y (X>Y) -p (print)\n");
  exit(1);
}
//affichage du tableau tab
void print_tab(char type,long tab[3])
{
	for (i=0;i<3;i++){
		fprintf(output,"%c%d: %d\n",type,i,tab[i]);
		fprintf(stdout,"%c%d: %d\n",type,i,tab[i]);
	}
	fprintf(output,"\n");
	fprintf(stdout,"\n");
} 
//initialisation of u and v
void etape1_inituv(){
	fprintf(output,"etape 1\n");
	//init u
	u[0]=1;
	u[1]=0;
	u[2]=x;
	if (print){
		print_tab('u',u);
	}
	//init v
	v[0]=0;
	v[1]=1;
	v[2]=y;
	if (print){
		print_tab('y',u);
	}
}
//calcul (t1,t2,t3) =(u1,u2,u3)-q(v1,v2,v3)
void calcul_q_t(){
	//calcul q
	int q=(int)(u[2]/v[2]);
	t[0]=u[0]-(q*v[0]);
	t[1]=u[1]-(q*v[1]);
	t[2]=u[2]-(q*v[2]);
	if (print){
		print_tab('t',t);
	}

}
void etape3(){
	fprintf(output,"etape 3\n");
	calcul_q_t();
	u[0]=v[0];
	u[1]=v[1];
	u[2]=v[2];
	if (print){
		print_tab('u',u);
	}
	v[0]=t[0];
	v[1]=t[1];
	v[2]=t[2];
	if (print){
		print_tab('v',v);
	}
}
//retourne 1 si il faut continuer
int etape2(){
	fprintf(output,"etape 2\n");
	if (v[2]==0)
	{
		U=u[0];
		V=u[1];
		return 0;
	}
	return 1;
}
//algo euclide etendu
void euclide_etendu()
{
	etape1_inituv();
	while (etape2())
	{
		etape3();
	}
}
long calcul_exposant_efficace(long base,long exp,long modulo)
{
	long D= 1;
	long bk= 0;
	long expk = 0;
	for (int k = 31 ; k>=0 ;k--)
	{
		
		fprintf(output,"k:%i ",k);
		D = (D*D)%modulo;
		expk= 1<<k;
		bk=(exp&expk);
		if (bk){
			D = (D*base)%modulo;
			fprintf(output,"bk:%i ",bk); 
		}
	}
	return (D);
}
int main(int argc, char* argv[])
{
	x=0;
	y=0;
	e=0;
	phi=0;
	i=1;
	output = fopen("resultats.txt","w");
	fprintf(output,"EUCLIDE_ETENDU\n");
	while(i < argc) 
	{
		if(strcmp(argv[i],"-x")==0 ) {
		  i++;
		   x= atol(argv[i]);
		}
		else if(strcmp(argv[i],"-y")==0) {
		  i++;
		  y= atol(argv[i]);
		}else if(strcmp(argv[i],"-p")==0) {
		  i++;
		  print =1;
		}else if(strcmp(argv[i],"-e")==0) {
		  i++;
		  e = atol(argv[i]);
		}else if(strcmp(argv[i],"-phi")==0) {
		  i++;
		  phi = atol(argv[i]);
		}
		i++;
	}
	if ((!x&&!y&&!(x>=y)) ||(!e&&!phi) ){
		usage();
	}
	if(!e)
	{   //calculons ux+vy=pgcd(x,y)
		euclide_etendu();
		fprintf(stdout," xu+yv = pgcd (x,y) \n %i*%i + %i*%i = pgcd(%i,%i) \n = %i \n",x,U,y,V,x,y,(U*x+V*y));
		fprintf(output," xu+yv = pgcd (x,y) \n %i*%i + %i*%i = pgcd(%i,%i) \n = %i \n",x,U,y,V,x,y,(U*x+V*y));
	}else
	{   //tronvons d tel que (e*d)u-(phi*v)=1 (u doit etre egale a 1) dont 
		// ceci revient au fait de calculer d tel que pgcd(e,phi)=1
		long pgcd =0;
		long d=0;
		while(d<= phi)
		{
			d++;
			x = e * d;
			y = -phi;
			euclide_etendu();
			pgcd=U*x+V*y;
			long signature =0;
			long message_decode =0;
			long message = 14;
			if (pgcd==1){
				fprintf(stdout,"possibilite d=%d u=%d v=%d\n",d,U,V);
				fprintf(output,"possibilite d=%d u=%d v=%d\n",d,U,V);
				signature = calcul_exposant_efficace(message,d,55);
				message_decode = calcul_exposant_efficace(signature,e,55);
				if ((message == message_decode) && (U ==1) ){
					fprintf(stdout,"\non a trouve le bon d=%d u=%d v=%d\n",d,U,V);
					fprintf(stdout,"(e * d)u - phi v = 1 \n");
					fprintf(stdout,"(%d * %d)%d - %d %d = 1 \n\n",e,d,U,phi,V);
					fprintf(output,"\non a trouve le bon d=%d x=%d y=%d\n",d,U,V);
					fprintf(output,"(e * d)u - phi v = 1 \n");
					fprintf(output,"(%d * %d)%d - %d %d = 1 \n\n",e,d,U,phi,V);
				}
			}
		}
	}
	fclose(output);
	return 0;
}
