// substitution_poly_alphabetique.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>



#define ERROR -65 //code de l'espace en int
#define DECAL 97  //decalage de la representation en ascii a = 97
#define NB_LETTERS 26
#define MAX 1000

char* phrase_arg = NULL; //phrase a chiffrer
char* phrase_a_dechiffrer = NULL;
int* phrase_a_dechiffrer_int = NULL; //phrase convertie en 0-25
char* phrase_chiffree = NULL;
int* phrase_chiffree_int= NULL;
char* phrase_dechiffree= NULL;
int* phrase_dechiffree_int= NULL;

//fichier input et output
FILE * output = NULL; 
char * outputfilename = NULL; 
FILE *input = NULL;
char *inputfilename =NULL;

int tab_dechiffrage_pair[NB_LETTERS]; //tableau de dchiffrage pair
int tab_dechiffrage_impair[NB_LETTERS];// tableau de dchiffrage impair
int tab_verification_dechiffrage_pair[NB_LETTERS];//tableau servant  verifier que la relation 1/1 des tableaux de dchiffrage
int tab_verification_dechiffrage_impair[NB_LETTERS];
float distribution_avant[NB_LETTERS+1];// ajout de l'espace (100% - total des lettres) 
float distribution_apres[NB_LETTERS+1];// ajout de l'espace (100% - total des lettres) 
int i,j,k; //counters
int a=11,b=3,c=5,d=0; //coefficients de chiffrages 
int seulement_dechiffrer = 0;
int size = 0; //longeur de la phrase
int affiche_distribution = 0;
int SECRET=0; // affichage de l'algo utilise dans l'explication de l'utilisation
int pair=1; //utile dans chiffrage et seulement_dechiffer


//chiffrage des positions paires 
int chiffrage_pair(int i)
{
	return (((a*i+b)%NB_LETTERS));
}
//chiffrage des positions impaires
int chiffrage_impair(int i)
{
	return (((c*i+d)%NB_LETTERS));
}
//dchiffrage des positions paires 
int dechiffer_pair(int i)
{
	for (k = 0; k<NB_LETTERS;k++){
		if (tab_dechiffrage_pair[k] == i){
			return k;
		}
	}
	return ERROR;
}
//dchiffrage des positions impaires 
int dechiffer_impair(int i)
{
	for (k = 0; k<NB_LETTERS;k++){
		if (tab_dechiffrage_impair[k] == i){
			return k;
		}
	}
	return ERROR; //code pour un espace
}
//usage de cette application
void usage() {
	fprintf(stderr,"Usage:  substitution_poly_alphabetique (francis pieraut 9 fev 2001)\n\n");
	fprintf(stderr,"[-D]	dechiffrer le message \n");
	fprintf(stderr,"[-dist] affiche la distribution des valeurs avant et apres \n");
	fprintf(stderr,"[-o]	mettre le resultat dans le fichier specifie \n");
	fprintf(stderr,"[-i]    fichier input (pas plus de 100 caracteres) \n");
	fprintf(stderr,"-p      la phrase a chiffrer ou dechiffrer\n");
	fprintf(stderr,"***     Par defaut les resultas seront places dans resultat.txt\n\n");
	if (SECRET){
	  fprintf(stderr,"[- a A -b B c C -d D] les coefficients du chiffreur \n");
	  fprintf(stderr,"paire'  = (a*paire+b) modulo 26 \n");
	  fprintf(stderr,"impaire'= (c*paire+d) modulo 26\n\n");
  }
  fprintf(stderr,"exemple substitution_poly_alphabetique -D -p fshuqmWxbwiTdmtwiuiTuaWmvkphnrvTkutTksqnvutTvrWpvmWxiszutmpmWpdntTpnWuqbnhbnqufuqrWoqzbhfaeoxwv\n\n");
  exit(1);
} 	
//calcul de distribution
void distribution(int size){
	int nb_avant=0;
	int nb_apres=0;
	for (k = 0; k<size;k++){
		if (phrase_dechiffree_int[k]<NB_LETTERS){
			distribution_avant[phrase_dechiffree_int[k]]++;
			nb_avant++;
		}
		if (phrase_chiffree_int[k]<NB_LETTERS){
			distribution_apres[phrase_chiffree_int[k]]++;
			nb_apres++;
		}
	}
	if (nb_avant!=nb_apres){
		fprintf(stderr,"\n\n erreur dans le calcul de distribution\n\n");
	}
	float somme_avant =0;
	float somme_apres =0;
	for (k = 0; k<NB_LETTERS;k++)
	{
		distribution_avant[k]= (distribution_avant[k]/size)*100 ;
		somme_avant +=distribution_avant[k];
		distribution_apres[k]=(distribution_apres[k]/size)*100;
		somme_apres +=distribution_apres[k];
	}
	distribution_avant[NB_LETTERS] = somme_avant;
	distribution_apres[NB_LETTERS] = somme_apres;

}
void affichage_init(FILE *output)
{
	fprintf(output,"Chiffrage par substitution poly-alphabetique (Francis Pieraut 8 fev 2001)\n\n");
}
//affichage des resultats 
void affiche_resultats(FILE *p_output,int commentaires)
{
	//afficher le resultat du dechiffrage 
	if (seulement_dechiffrer)
	{
		if (commentaires && (p_output == stdout))
			fprintf(p_output,"voici le resultat du dechiffrage : \n");
		for (i=0; i<=size; i++){
			fprintf(p_output,"%c",phrase_dechiffree[i]);
		}
		fprintf(p_output,"\n");
	}else
	{
		//afficher le resultat du chiffrage
		if (commentaires)
			fprintf(p_output,"voici le resultat du chiffrage : \n");
		for (i=0; i<=size; i++){
			fprintf(p_output,"%c",phrase_chiffree[i]);
		}
		fprintf(p_output,"%c",(ERROR+DECAL));
	}
}

//affiche les distributions avant et apres
void affiche_distributions(FILE *p_output)
{
	if (affiche_distribution)
	{
		fprintf(p_output,"\n\n Distribution avant et apres chiffrage: \n");
		for (k = 0; k<NB_LETTERS;k++)
		{
			fprintf(p_output,"%c :",(char)(k+DECAL));
			fprintf(p_output," %3.3f   %3.3f  \n",distribution_avant[k],distribution_apres[k]);
		}
		fprintf(p_output,"  : %3.3f   %3.3f  \n",(100-distribution_avant[NB_LETTERS]),(100-distribution_apres[NB_LETTERS]));
	}
}
void intialisation_memory(int size)
{
	//initialisation
	phrase_chiffree  = (char*)calloc(size+1,sizeof(char)); 
	phrase_chiffree_int = (int*)calloc(size+1,sizeof(int)); 
	phrase_dechiffree= (char*)calloc(size+1,sizeof(char)); 
	phrase_dechiffree_int= (int*)calloc(size+1,sizeof(int)); 
	phrase_a_dechiffrer =(char*)calloc(size+1,sizeof(int));
	phrase_a_dechiffrer_int=(int*)calloc(size+1,sizeof(int));
}
void free_memory()
{
	//initialisation
	free(phrase_chiffree);  
	free(phrase_chiffree_int); 
	free(phrase_dechiffree);
	free(phrase_dechiffree_int);
	free(phrase_a_dechiffrer); 
	free(phrase_a_dechiffrer_int);
	fclose(output);
}
void initialisation()	
{
	// ajustement si c'est un fichier qu'il faut dechiffrer
	if (inputfilename){
		input = fopen(inputfilename,"r");
	}
	if (input){
		char temp[MAX];
		//int size_premier = fscanf(input,"%s",phrase_a_dechiffrer);
		intialisation_memory(MAX);
		//size = size_premier;
		char temp2=' ';
		int i=0;
		while ( (temp[i]= getc(input)) != EOF)
			i++;
		size = i;
		intialisation_memory(i);
		memcpy(phrase_a_dechiffrer,temp,size);
		
	}else{ //si il faut dechiffrer l argument de la cmdline
		intialisation_memory(size);
		//la phrase phrase_arg doit etre dechiffree ou chiffree
		memcpy(phrase_a_dechiffrer,phrase_arg,size);
	}
	//ajustement pour option -d (seulement_dechiffer) la phrase est a dechiffrer
	if (seulement_dechiffrer){
		if (input){
			memcpy(phrase_chiffree,phrase_a_dechiffrer,size);
		}else{//cmdline
			memcpy(phrase_chiffree,phrase_arg,size);
		}
		//creation de phrase_chiffree_int
		for (i=0; i<=size; i++)
			phrase_chiffree_int[i]=(char)((int)phrase_chiffree[i] - DECAL);
	}

	//ajustement pour l'option -o (dechiffrer et mettre le resultat dans un fichier)
	if (outputfilename){
		output=fopen(outputfilename,"w");
	}else{
		//output par defaut
		output=fopen("resultat.txt","w");
	}
	
}
void get_next_phrase_a_dechiffrer()
{
	if (input){
		//fscanf(input,"%s",phrase_a_dechiffrer);
		if (fscanf(input,"%s",phrase_a_dechiffrer)==EOF){
			phrase_a_dechiffrer=NULL;
		}else{
			 size =strlen(phrase_a_dechiffrer);
		}

	}else{
		phrase_a_dechiffrer=NULL;
	}
}
//chiffrage
void chiffrage()
{
	pair = 1;
	for (i=0; i<size; i++)
	{
		if (pair)
			phrase_chiffree_int[i]=chiffrage_pair((const) (phrase_a_dechiffrer_int[i]));
		else
			phrase_chiffree_int[i]=chiffrage_impair((const)(phrase_a_dechiffrer_int[i]));
		pair=(!pair);
		phrase_chiffree[i]=(char)((int)phrase_chiffree_int[i] + DECAL);
	}
}
//cration des tableaux de dchiffrage
void Creation_tabs_dechiffrage()
{
	for (i=0;i<NB_LETTERS;i++)
	{
		tab_dechiffrage_pair[i]= chiffrage_pair(i);
		tab_dechiffrage_impair[i]=chiffrage_impair(i);
	}
	//verfication de la table de dechiffrage pair
	for (i=0;i<NB_LETTERS;i++)
	{
		if (tab_verification_dechiffrage_pair[(tab_dechiffrage_pair[i])] == 0){
			tab_verification_dechiffrage_pair[(tab_dechiffrage_pair[i])] = 1;
		}else{
			fprintf(stderr,"Erreur, il existe deux dechiffrages distinct pour la meme lettre pair"); 
		}
	}
	//verfication de la table de dechiffrage impapair
	for (i=0;i<NB_LETTERS;i++)
	{
		if (tab_verification_dechiffrage_impair[(tab_dechiffrage_pair[i])] == 0){
			tab_verification_dechiffrage_impair[(tab_dechiffrage_pair[i])] = 1;
		}else{
			fprintf(stderr,"Erreur, il existe deux dechiffrages distinct pour la meme lettre impair"); 
		}
	}

}
//dchiffrage
void dechiffrage()
{
	pair = 1;
	for (i=0; i<=size; i++)
	{
		if (pair)
			phrase_dechiffree_int[i]= dechiffer_pair(phrase_chiffree_int[i]);
		else
			phrase_dechiffree_int[i]= dechiffer_impair(phrase_chiffree_int[i]); 
		pair=(!pair);
		phrase_dechiffree[i]=phrase_dechiffree_int[i] + DECAL;
	}
}
// transformation de la phrase a dechiffrer en int (0-25)
void transformation_int()
{
 	for (i=0; i<size; i++)
	{
			phrase_a_dechiffrer_int[i]=(int)(((int)phrase_a_dechiffrer[i]) - DECAL);
	}
}
// chiffrage et dchiffrage de phrase_a_dechiffrer
int main(int argc, char* argv[])
{
	//traitement des arguments 
	i =1;
	while(i < (argc)) 
	{
		if(strcmp(argv[i],"-p")==0) 
		{
		  i++;
		  phrase_arg = argv[i];
		  size =strlen(phrase_arg);
		}else if(strcmp(argv[i],"-o")==0) 
		{
		  i++;
		  outputfilename = argv[i];
		}
		else if(strcmp(argv[i],"-i")==0) 
		{
		  i++;
		  inputfilename = argv[i];
		}
		else if(strcmp(argv[i],"-D")==0 ) 
		{
		  i++;
		  seulement_dechiffrer = 1;
		}else if(strcmp(argv[i],"-dist")==0 ) 
		{
		  i++;
		  affiche_distribution = 1;
		  
		}
		else if(strcmp(argv[i],"-a")==0 ) 
		{
		  i++;
		  a=atoi(argv[i]);
		  
		}
		else if(strcmp(argv[i],"-b")==0 ) 
		{
		  i++;
		  b=atoi(argv[i]);
		  
		}
		else if(strcmp(argv[i],"-c")==0 ) 
		{
		  i++;
		  c=atoi(argv[i]);
		 
		}
		else if(strcmp(argv[i],"-d")==0 ) 
		{
		  i++;
		  d=atoi(argv[i]);
		  
		}
		else if(strcmp(argv[i],"-FP")==0 ) 
		{
		  i++;
		  SECRET=1;
		  
		}else i++;

	}
	initialisation();
	//verification qu'il y a quelque chose a chiffrer ou dechiffrer
	if ( ((!phrase_arg) && (!input))||((phrase_arg) && (input)) ){
		usage();
	}
	affichage_init(stdout);
	Creation_tabs_dechiffrage();

	//dechiffrons les messages
	transformation_int();
	if (!seulement_dechiffrer){
		chiffrage();
	}
	dechiffrage();
	//appel du calcul des distributions (update)
	distribution(size);
	//affichage des resultats
	affiche_resultats(output,0);
	affiche_resultats(stdout,1);
	//get_next_phrase_a_dechiffrer();
	//afficage des distributions
	affiche_distributions(stdout);
	if (seulement_dechiffrer || affiche_distribution){
		affiche_distributions(output);
	}
	fprintf(stdout,"\n\n");
	free_memory();
	return 0;
}
